﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

namespace SpawnMapper
{
    public partial class MainForm : Form
    {
        //Variables used below and for testing
        //string SaveLocation = "C:\\temp";   //\pkg\systems\spawnSystem\config
        string SpawnFile = "";              //Default but changing to open dialogue selection.
        string GroupFile = "";              //MOB groups used by spawnsystem
        
        string TheFile = "";                //string read from SpawnFile with empty lines & comments removed
        string TheWholeFile = "";           //same as "TheFile", I just want to keep a copy - I'm a hoarder.. might use it later
        string UOSpawnsToSave = "";         //string used when saving List<SpawnZone> UOSpawns
        string CustomSpawnsToSave = "";     //string used when saving List<SpawnZone> CustomZones
        
        string NewGroupFile = "";           //MOB groups

        string TheSaveFile = "";            //cleaned-up SpawnFile - empty lines and comments taken out.

        string WhatSpawn = "";
        string C_WhatSpawn = "";
        int SelectedUOSpawn = 0;
        int C_SelectedC_Spawn = 0;
        int EditUOSpawn = 0;
        int EditC_Spawn = 0;

        int ZoomFactor = 1;
        int spawnX1 = 0;
        int spawnY1 = 0;
        int spawnX2 = 0;
        int spawnY2 = 0;

        public MainForm()
        {
            InitializeComponent();
            //CheckPath(SaveLocation);  //c:\temp used in testing so no point not checking that first.
        }
        //Select Map first to setup
        private void comboBox7_SelectedIndexChanged(object sender, EventArgs e)
        {
            MapRefresh();
            cbZoomX1.Enabled = true;
            cbZoomX2.Enabled = true;
            cbZoomX4.Enabled = true;
        }
        //What happens when you click the LOAD button
        private void LoadButton_Click(object sender, EventArgs e)
        {
            //MessageBox.Show("Browse to and open your \"spawn MAP\" file for the selected realm.", "Next Action!", MessageBoxButtons.OK, MessageBoxIcon.Information);
            SpawnFile = GetFile();                  //using getfiledialouge to allow selecting files
            TheFile = ReadFromFile(SpawnFile);      //read text spawns file into one big string
                                                    //ReadFromFile did some cleanup.. ie single line comments (// or #) and empty lines
            SplitToSpawnArray();                    //split the string into a list of arrays

            PutZonesAsArrayIntoSpawnZoneList();     //This is where I am creating my SpawnZone objects and storing into list.
                
            FillZoneListBox();                      //populate zone names to the listbox
            //MessageBox.Show("Browse to and open your \"DefaultGroups\" file.", "Next Action!", MessageBoxButtons.OK, MessageBoxIcon.Information);
            GroupFile = GetFile();
            NewGroupFile = ReadGroupFile(GroupFile);//read in the group names from the defaultGroups.cfg
            PutMobListSomewhere();
            LoadButton.Enabled = false;             //don't want to accidentally reload over unsaved changes.
            buttonDrawAll.Enabled = true;
            buttonDelete.Enabled = true;
        }
        //What happens when you select an item from the spawn list.
        private void ZoneListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            consoleBox.Clear();
            ClearOldInfo(); //Clear out the old info FIRST!!
            WhatSpawn =  ZoneListBox.SelectedItem.ToString();
            PopulateInfo(WhatSpawn);
            DrawButton.Enabled = true;
            buttonDrawAll.Enabled = true;
        }
        //What happens when selecting a custom spawn  -allows to edit info
        private void CustomListBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            consoleBox.Clear();
            ClearOldInfo(); //Clear out the old info FIRST!!
            C_WhatSpawn = CustomListBox.SelectedItem.ToString();
            C_PopulateInfo(C_WhatSpawn);
        }
        //What happens when you click the DRAW button
        private void DrawButton_Click(object sender, EventArgs e)
        {
            DrawSpawn(Data.UOSpawns[SelectedUOSpawn]);
            if (Data.UOSpawns[SelectedUOSpawn].X1 > 600)
            {
                MapFrame.HorizontalScroll.Value = (Data.UOSpawns[SelectedUOSpawn].X1 - 400);
            }
            if (Data.UOSpawns[SelectedUOSpawn].Y1 > 600)
            {
                MapFrame.VerticalScroll.Value = (Data.UOSpawns[SelectedUOSpawn].Y1 - 400);
            }
            Map.Refresh();
            ReDrawSpawn();
        }
        //Draw ALL spawns
        private void buttonDrawAll_Click(object sender, EventArgs e)
        {
            DrawALLSpanws();
        }
        //What happens when you click the SAVE button
        private void SaveButton_Click(object sender, EventArgs e)
        {
            SaveSpawnZoneClassBackToCurlyBrace_CFG_File();
            consoleBox.AppendText("Save completed.");
        }
        //What happens when you click the Custom SAVE button
        private void buttonC_Save_Click(object sender, EventArgs e)
        {
            SaveCustomZoneClassBackToCurlyBrace_CFG_File();
            consoleBox.AppendText("Save completed.");
        }
        //added in a zoom X1,X2,X4 option..
        private void cbZoomX1_CheckStateChanged(object sender, EventArgs e)
        {
            if (cbZoomX1.Checked == true)
            {
                cbZoomX2.Checked = false;
                cbZoomX4.Checked = false;
                ZoomFactor = (1);
                MapRefresh();
                consoleBox.Clear();
                consoleBox.AppendText("Zoom set to 1X.");
            }
        }
        private void cbZoomX2_CheckedChanged(object sender, EventArgs e)
        {
            if (cbZoomX2.Checked == true)
            {
                cbZoomX1.Checked = false;
                cbZoomX4.Checked = false;
                ZoomFactor = (2);
                MapRefresh();
                consoleBox.Clear();
                consoleBox.AppendText("Zoom set to 2X.");
            }
        }
        private void cbZoomX4_CheckStateChanged(object sender, EventArgs e)
        {
            if (cbZoomX4.Checked == true)
            {
                cbZoomX1.Checked = false;
                cbZoomX2.Checked = false;
                ZoomFactor = (4);
                MapRefresh();
                consoleBox.Clear();
                consoleBox.AppendText("Zoom set to 4X.");
            }

        }
        //click map to redraw boxes
        private void Map_Click(object sender, EventArgs e)
        {
            ReDrawSpawn();
        }
        //Paint Event to try refresh objects
        private void Map_Paint(object sender, PaintEventArgs e)
        {
            ReDrawSpawn();
        }
        //Clear ALL the drawings
        private void buttonClear_Click(object sender, EventArgs e)
        {
            Data.RedrawZones.Clear();
            Data.CustomZones.Clear();
            Map.Refresh();
        }
        //Remove last custom rectangle from list and redraw
        private void buttonClearLast_Click(object sender, EventArgs e)
        {
            ClearLast();
        }
        //Remove last listbox Selected SpawnZone
        private void buttonClearLastZone_Click(object sender, EventArgs e)
        {
            ClearLastSelected();
        }
        //Show mouse co-ords over map.
        private void Map_MouseMove(object sender, MouseEventArgs e)
        {
            labelMouse.Text = ("X= " + (e.X / ZoomFactor).ToString() + " Y= " + (e.Y / ZoomFactor).ToString());
        }
        //to drag-draw rectangle. MouseDown = x1,y1
        private void Map_MouseDown(object sender, MouseEventArgs e)
        {
            if (checkBoxDM.Checked)
            {
                ClearOldInfo(); //Clear out the old info FIRST!!

                consoleBox.AppendText("Drawing Mode.");
                textBoxX1.Text = (e.X / ZoomFactor).ToString();
                spawnX1 = (e.X/ ZoomFactor);
                textBoxY1.Text = (e.Y / ZoomFactor).ToString();
                spawnY1 = (e.Y/ ZoomFactor);

            }
            ReDrawSpawn();
        }
        //to drag-draw rectangle. MouseUp = x2,y2. then send co-ords to draw rect
        private void Map_MouseUp(object sender, MouseEventArgs e)
        {
            if (checkBoxDM.Checked)
            {
                
                textBoxX2.Text = (e.X / ZoomFactor).ToString();
                spawnX2 = (e.X/ ZoomFactor);
                textBoxY2.Text = (e.Y / ZoomFactor).ToString();
                spawnY2 = (e.Y/ ZoomFactor);
                textBoxName.Text = (textBoxX1.Text + textBoxY1.Text + textBoxX2.Text + textBoxY2.Text);
                ConfirmDrawSpawn(spawnX1, spawnY1, spawnX2, spawnY2);
                AddToCustomList(spawnX1, spawnY1, spawnX2, spawnY2);
            }
            ReDrawSpawn();
        }
        //Update the UoSpawns populated by listbox - editing the spawns read in from file
        private void buttonUpdate_Click(object sender, EventArgs e)
        {
            SpawnZone_Update();
        }
        //Update the CustomSpawns after editing.
        private void buttonC_Update_Click(object sender, EventArgs e)
        {
            C_Update();
        }
        //Delete a spawn from the inported listbox
        private void buttonDelete_Click(object sender, EventArgs e)
        {
            SpawnZone_Delete();
        }
        //######################################################################################
        //######################################################################################
        //Map Select/Change
        private void MapRefresh()
        {
            string WhatMap = comboBox7.SelectedItem.ToString();
            switch (WhatMap)
            {
                case "Felucca":
                    consoleBox.AppendText("Selected map Felucca, Setting map size and graphic.");
                    Map.Image = SpawnMapper.Properties.Resources.Felucca;
                    MapFrame.AutoScrollMinSize = new Size((6144 * ZoomFactor), (4096 * ZoomFactor));
                    checkBoxDM.Enabled = true;
                    LoadButton.Enabled = true;
                    break;
                case "Trammel":
                    consoleBox.AppendText("Selected map Trammel, Setting map size and graphic.");
                    Map.Image = SpawnMapper.Properties.Resources.Trammel;
                    MapFrame.AutoScrollMinSize = new Size((6144 * ZoomFactor), (4096 * ZoomFactor));
                    checkBoxDM.Enabled = true;
                    LoadButton.Enabled = true;
                    break;
                case "Ilshenar":
                    consoleBox.AppendText("Selected map Ilshenar, Setting map size and graphic.");
                    Map.Image = SpawnMapper.Properties.Resources.Ilshenar;
                    MapFrame.AutoScrollMinSize = new Size((2304 * ZoomFactor), (1600 * ZoomFactor));
                    checkBoxDM.Enabled = true;
                    LoadButton.Enabled = true;
                    break;
                case "Malas":
                    consoleBox.AppendText("Selected map Malas, Setting map size and graphic.");
                    Map.Image = SpawnMapper.Properties.Resources.Malas;
                    MapFrame.AutoScrollMinSize = new Size((2560 * ZoomFactor), (2048 * ZoomFactor));
                    checkBoxDM.Enabled = true;
                    LoadButton.Enabled = true;
                    break;
                case "Tokuno":
                    consoleBox.AppendText("Selected map Tokuno, Setting map size and graphic.");
                    Map.Image = SpawnMapper.Properties.Resources.Tokuno;
                    MapFrame.AutoScrollMinSize = new Size((1448 * ZoomFactor), (1448 * ZoomFactor));
                    checkBoxDM.Enabled = true;
                    LoadButton.Enabled = true;
                    break;
                case "Termur":
                    consoleBox.AppendText("Selected map Termur, Setting map size and graphic.");
                    Map.Image = SpawnMapper.Properties.Resources.Termur;
                    MapFrame.AutoScrollMinSize = new Size((1280 * ZoomFactor), (4096 * ZoomFactor));
                    checkBoxDM.Enabled = true;
                    LoadButton.Enabled = true;
                    break;
                default:
                    consoleBox.AppendText("Selected map Felucca, Setting map size and graphic.");
                    Map.Image = SpawnMapper.Properties.Resources.Felucca;
                    MapFrame.AutoScrollMinSize = new Size((6144 * ZoomFactor), (4096 * ZoomFactor));
                    checkBoxDM.Enabled = true;
                    LoadButton.Enabled = true;
                    break;
            }
        }
        //Check the path exists, if not - create it
        private void CheckPath(string _SaveLocation)
        {
            //Check for folder and create if needed
            if (!Directory.Exists(_SaveLocation))
            {
                Directory.CreateDirectory(_SaveLocation);
            }
        }
        //SaveFile Dialogue
        private string SaveFile()
        {
            SaveFileDialog sfd = new SaveFileDialog();
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                return sfd.FileName;
            }
            else
            {
                return "Invalid";
            }
        }
        //Append string to file 2 over-rides
        private void AddToFile(string _WhatToPutInFile)
        {
            StreamWriter MyFile = new StreamWriter("c:\\temp\\MyFile.cfg", true);     //true is to append to existing, only create if not there.
            MyFile.WriteLine(_WhatToPutInFile);
            MyFile.Close();
        }
        private void AddToFile(string _WhatToPutInFile, string _FileName)
        {

            StreamWriter MyFile = new StreamWriter(_FileName, false);     //"true" forces appending to file.
            MyFile.WriteLine(_WhatToPutInFile);
            MyFile.Close();
        }
        private void AddToFile(string _WhatToPutInFile, string _FileName, bool _Overwrite)
        {

            StreamWriter MyFile = new StreamWriter(_FileName, _Overwrite);     //"true" forces appending to file.
            MyFile.WriteLine(_WhatToPutInFile);
            MyFile.Close();
        }
        //OpenFile Dialogue
        private string GetFile()
        {
            OpenFileDialog ofd = new OpenFileDialog();
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                return ofd.FileName;
            }
            else
            {
                return "Invalid";
            }
        }
        //Reads the file and returns the entire contents as a string.
        private string ReadFromFile(string _FileName)
        {
            try
            {
                StreamReader myReader = new StreamReader(_FileName);
                string ThisLine = "";
                string dumpline = "";

                while (ThisLine != null)
                {
                    ThisLine = myReader.ReadLine();

                    if ((ThisLine == null) || (ThisLine == "") || (ThisLine == " "))
                        dumpline = ThisLine;
                    else if (CheckStr(ThisLine) == false)
                        dumpline = ThisLine;
                    else
                    {
                        TheSaveFile += (ThisLine + " \n ");
                        //want to remove the opening brace "{" from the results
                        //still use the closing brace "}" as a line split char.
                        //need braces in the "save file" else i have to add them back when saving
                        if (ThisLine == "{")
                        { dumpline = ThisLine; }
                        else
                        {
                            TheWholeFile += (ThisLine);
                        }
                    }
                }
                myReader.Close();
                return TheWholeFile;
            }
            catch (DirectoryNotFoundException e)
            {
                consoleBox.AppendText(e.Message);
                return " Sorry.. error ";
            }
            catch (FileNotFoundException e)
            {
                consoleBox.AppendText(e.Message);
                return " Sorry.. error ";
            }
            catch (Exception e)
            {
                consoleBox.AppendText("oh Fuck! You broke it!" + e.Message);
                return " Sorry.. error ";
            }
        }
        //check if a string contains a substring - boolean result
        private bool CheckStr(string _string)
        {
            if (_string.Contains("#"))
                return false;
            if (_string.Contains("//"))
                return false;
            //if (_string.Contains("SpawnWait"))
            //    return false;
            else
                return true;
        }
        //clean out unwanted lines- boolean result
        private bool CleanStr(string _string)
        {
            if (_string.Contains("#"))
                return false;
            if (_string.Contains("//"))
                return false;
            //if (_string.Contains("SpawnWait"))
            //    return false;
            else
                return true;
        }
        //splitting string elements to array and list
        private void SplitToSpawnArray()
        {
            string STR_Element = "";
            string breaker = "}";   //kept "}" till now to use as it marks end of my POL spawn element.
                                    //Using it now to break my big string into an array of smaller strings.
            string[] Elements = TheFile.Split(new string[] { breaker }, StringSplitOptions.RemoveEmptyEntries);

            //create array called splitelement and add into list<>
            for (int i = 0; i < Elements.Length; i++)
            {
                STR_Element = Elements[i].ToString();
                string[] splitElement = SplitElements(STR_Element);
                Data.ZonesAsArray.Add(splitElement);
            }

            //just checking that I can read the list<array[]>
            consoleBox.AppendText("Read in " + Data.ZonesAsArray.Count + " spawn elements.");
        }
        //Split a string into an array of strings - breaks into words
        private string[] SplitElements(string _Elements)
        {
            string[] spawnz = _Elements.Split(new string[] { "\n", "\r\n", " ", "\t" }, StringSplitOptions.RemoveEmptyEntries);
            return spawnz;
        }
        //######################################################################################
        //######################################################################################
        //Draw SpawnZone using the SpawnZone class
        private void DrawSpawn(SpawnZone CurrentSpawn)
        {
            if ((CurrentSpawn.X1 < CurrentSpawn.X2) && (CurrentSpawn.Y1 < CurrentSpawn.Y2))
            {
                int Width = ((CurrentSpawn.X2 * ZoomFactor) - (CurrentSpawn.X1 * ZoomFactor));
                int Height = ((CurrentSpawn.Y2 * ZoomFactor) - (CurrentSpawn.Y1 * ZoomFactor));
                Color zzz = Colourise();
                Rectangle SpawnBox = new Rectangle((CurrentSpawn.X1 * ZoomFactor), (CurrentSpawn.Y1 * ZoomFactor), Width, Height);
                using (Pen thisPen = new Pen(zzz, 1))
                { Map.CreateGraphics().DrawRectangle(thisPen, SpawnBox); }
                using (Font thisFont = new Font("Arial", 10))
                { Map.CreateGraphics().DrawString(CurrentSpawn.Name, thisFont, Brushes.GreenYellow, new Point((CurrentSpawn.X1 * ZoomFactor) + 10, (CurrentSpawn.Y1 * ZoomFactor))); }
                Data.RedrawZones.Add(CurrentSpawn);
            }
            else { consoleBox.AppendText("Please check x1,y1 = top left corner " + CurrentSpawn); }
        }
        //Draw ALL spawns to map
        private void DrawALLSpanws()
        {

            for (int i = 0; i < Data.UOSpawns.Count; i++)
            {
                SpawnZone thisSpawnZone = Data.UOSpawns[i];
                DrawSpawn(thisSpawnZone);
            }
        }
        //Clear last of the selected from listbox spawnzones
        private void ClearLastSelected()
        {
            int x = (Data.RedrawZones.Count - 1);   //crashes if I remove the first entry
            if (x > 0)
            {
                consoleBox.AppendText(Data.RedrawZones[x].ToString());
                Data.RedrawZones.RemoveAt(x);
            }
            Map.Refresh();
            ReDrawSpawn();
        }
        //populate the ListBox with the zone names.
        private void FillZoneListBox()
        {
            ZoneListBox.Items.Add("Blank");
            for (int i = 0; i < Data.UOSpawns.Count; i++)
                {
                    if(Data.UOSpawns[i].Name ==null)
                    {
                        Data.UOSpawns[i].Name = "BrokenSpawnName";
                    }
                    ZoneListBox.Items.Add(Data.UOSpawns[i].Name);
                }
        }
        //populate the info for selected ListBox item.
        private void PopulateInfo(string _WhatSpawn)
        {
            if (_WhatSpawn == "Blank")
            {
                ClearOldInfo();
            }
            else
            {
                for (int i = 0; i < Data.UOSpawns.Count; i++)
                {
                    if (Data.UOSpawns[i].Name == _WhatSpawn)
                        SelectedUOSpawn = i;
                }
                buttonUpdate.Enabled = true;
                consoleBox.AppendText("The selected element is: " + Data.UOSpawns[SelectedUOSpawn].Name);
                textBoxName.Text = _WhatSpawn;
                textBoxX1.Text = Data.UOSpawns[SelectedUOSpawn].X1.ToString();
                textBoxY1.Text = Data.UOSpawns[SelectedUOSpawn].Y1.ToString();
                textBoxX2.Text = Data.UOSpawns[SelectedUOSpawn].X2.ToString();
                textBoxY2.Text = Data.UOSpawns[SelectedUOSpawn].Y2.ToString();
                textBoxDelay.Text = Data.UOSpawns[SelectedUOSpawn].tDelay.ToString();
                PopulateMobInfo(SelectedUOSpawn);  //making it separate for readability and testing
            }
        }
        //populate the Mob combolist and amount for the selected SpawnZone
        private void PopulateMobInfo(int S_UOSpawn) //just shortening the "SelectedUOSpawn"
        {
            if ((Data.UOSpawns[S_UOSpawn].Mob1) != null)
            {
                comboBox1.Text = Data.UOSpawns[S_UOSpawn].Mob1;
                textBox1.Text = Data.UOSpawns[S_UOSpawn].Amount1.ToString();
            }
            if (Data.UOSpawns[S_UOSpawn].Mob2 != null)
            {
                comboBox2.Text = Data.UOSpawns[S_UOSpawn].Mob2;
                textBox2.Text = Data.UOSpawns[S_UOSpawn].Amount2.ToString();
            }
            if (Data.UOSpawns[S_UOSpawn].Mob3 != null)
            {
                comboBox3.Text = Data.UOSpawns[S_UOSpawn].Mob3;
                textBox3.Text = Data.UOSpawns[S_UOSpawn].Amount3.ToString();
            }
            if (Data.UOSpawns[S_UOSpawn].Mob4 != null)
            {
                comboBox4.Text = Data.UOSpawns[S_UOSpawn].Mob4;
                textBox4.Text = Data.UOSpawns[S_UOSpawn].Amount4.ToString();
            }
            if (Data.UOSpawns[S_UOSpawn].Mob5 != null)
            {
                comboBox5.Text = Data.UOSpawns[S_UOSpawn].Mob5;
                textBox5.Text = Data.UOSpawns[S_UOSpawn].Amount5.ToString();
            }
            if (Data.UOSpawns[S_UOSpawn].Mob6 != null)
            {
                comboBox6.Text = Data.UOSpawns[S_UOSpawn].Mob6;
                textBox6.Text = Data.UOSpawns[S_UOSpawn].Amount6.ToString();
            }
        }
        //Save SpawnZone back to cfg file
        private void SaveSpawnZoneClassBackToCurlyBrace_CFG_File()
        {
            consoleBox.Clear();
            UOSpawnsToSave = "#saving spawns#\r\n";
            for (int i = 0; i < Data.UOSpawns.Count; i++)
            {
                UOSpawnsToSave += ("Region \t");
                UOSpawnsToSave += (Data.UOSpawns[i].Name + "\r\n{\r\n\tCoords\t");
                UOSpawnsToSave += (Data.UOSpawns[i].X1.ToString() + "\t");
                UOSpawnsToSave += (Data.UOSpawns[i].Y1.ToString() + "\t");
                UOSpawnsToSave += (Data.UOSpawns[i].X2.ToString() + "\t");
                UOSpawnsToSave += (Data.UOSpawns[i].Y2.ToString() + "\r\n");
                UOSpawnsToSave += ("\tSpawnWait\t" + Data.UOSpawns[i].tDelay.ToString() + "\r\n");
                if ((Data.UOSpawns[i].Mob1) != null)
                {
                    UOSpawnsToSave += ("\tGroup\t" + Data.UOSpawns[i].Mob1);
                    UOSpawnsToSave += ("\t" + Data.UOSpawns[i].Amount1.ToString() + "\r\n");
                }
                if (Data.UOSpawns[i].Mob2 != null)
                {
                    UOSpawnsToSave += ("\tGroup\t" + Data.UOSpawns[i].Mob2);
                    UOSpawnsToSave += ("\t" + Data.UOSpawns[i].Amount2.ToString() + "\r\n");
                }
                if (Data.UOSpawns[i].Mob3 != null)
                {
                    UOSpawnsToSave += ("\tGroup\t" + Data.UOSpawns[i].Mob3);
                    UOSpawnsToSave += ("\t" + Data.UOSpawns[i].Amount3.ToString() + "\r\n");
                }
                if (Data.UOSpawns[i].Mob4 != null)
                {
                    UOSpawnsToSave += ("\tGroup\t" + Data.UOSpawns[i].Mob4);
                    UOSpawnsToSave += ("\t" + Data.UOSpawns[i].Amount4.ToString() + "\r\n");
                }
                if (Data.UOSpawns[i].Mob5 != null)
                {
                    UOSpawnsToSave += ("\tGroup\t" + Data.UOSpawns[i].Mob5);
                    UOSpawnsToSave += ("\t" + Data.UOSpawns[i].Amount5.ToString() + "\r\n");
                }
                if (Data.UOSpawns[i].Mob6 != null)
                {
                    UOSpawnsToSave += ("\tGroup\t" + Data.UOSpawns[i].Mob6);
                    UOSpawnsToSave += ("\t" + Data.UOSpawns[i].Amount6.ToString() + "\r\n");
                }
                UOSpawnsToSave += ("}\r\n");

            }
            string SaveHereSP = SaveFile();
            AddToFile(UOSpawnsToSave, SaveHereSP);
        }
        //Editing of the UOSpawns read from file
        private void SpawnZone_Update()
        {
            for (int i = 0; i < Data.UOSpawns.Count; i++)
            {
                if (Data.UOSpawns[i].Name == ZoneListBox.SelectedItem.ToString())
                    EditUOSpawn = i;
            }
            Data.UOSpawns[EditUOSpawn].Name = textBoxName.Text;
            Data.UOSpawns[EditUOSpawn].X1 = int.Parse(textBoxX1.Text);
            Data.UOSpawns[EditUOSpawn].Y1 = int.Parse(textBoxY1.Text);
            Data.UOSpawns[EditUOSpawn].X2 = int.Parse(textBoxX2.Text);
            Data.UOSpawns[EditUOSpawn].Y2 = int.Parse(textBoxY2.Text);
            Data.UOSpawns[EditUOSpawn].tDelay = int.Parse(textBoxDelay.Text);
            if((comboBox1.Text != "") && (textBox1.Text != ""))
            {
                Data.UOSpawns[EditUOSpawn].Mob1 = comboBox1.Text;
                Data.UOSpawns[EditUOSpawn].Amount1 = int.Parse(textBox1.Text);
            }
            if ((comboBox2.Text != "") && (textBox2.Text != ""))
            {
                Data.UOSpawns[EditUOSpawn].Mob2 = comboBox2.Text;
                Data.UOSpawns[EditUOSpawn].Amount2 = int.Parse(textBox2.Text);
            }
            if ((comboBox3.Text != "") && (textBox3.Text != ""))
            {
                Data.UOSpawns[EditUOSpawn].Mob3 = comboBox3.Text;
                Data.UOSpawns[EditUOSpawn].Amount3 = int.Parse(textBox3.Text);
            }
            if ((comboBox4.Text != "") && (textBox4.Text != ""))
            {
                Data.UOSpawns[EditUOSpawn].Mob4 = comboBox4.Text;
                Data.UOSpawns[EditUOSpawn].Amount4 = int.Parse(textBox4.Text);
            }
            if ((comboBox5.Text != "") && (textBox5.Text != ""))
            {
                Data.UOSpawns[EditUOSpawn].Mob5 = comboBox5.Text;
                Data.UOSpawns[EditUOSpawn].Amount5 = int.Parse(textBox5.Text);
            }
            if ((comboBox6.Text != "") && (textBox6.Text != ""))
            {
                Data.UOSpawns[EditUOSpawn].Mob6 = comboBox6.Text;
                Data.UOSpawns[EditUOSpawn].Amount6 = int.Parse(textBox6.Text);
            }

            ZoneListBox.Items.Clear();
            FillZoneListBox();
        }
        //delete selected item
        private void SpawnZone_Delete()
        {
            for (int i = 0; i < Data.UOSpawns.Count; i++)
            {
                
                if (Data.UOSpawns[i].Name == ZoneListBox.SelectedItem.ToString())
                {
                    int TheSelection = ZoneListBox.SelectedIndex;
                    string DEL = ZoneListBox.SelectedItem.ToString();
                    ZoneListBox.SelectedItem = ("Blank");
                    Data.UOSpawns.RemoveAt(i);
                    ZoneListBox.Items.Remove(DEL);
                    consoleBox.AppendText("\r\nremoved ?");
                }
            }
        }
        //Redraw ALL on action
        private void ReDrawSpawn()
        {
            for (int i = 0; i < Data.RedrawZones.Count; i++)
            {
                SpawnZone CurrentSpawn = Data.RedrawZones[i];
                Color zzz = Colourise();
                int Width = ((CurrentSpawn.X2 * ZoomFactor) - (CurrentSpawn.X1 * ZoomFactor));
                int Height = ((CurrentSpawn.Y2 * ZoomFactor) - (CurrentSpawn.Y1 * ZoomFactor));
                Rectangle SpawnBox = new Rectangle((CurrentSpawn.X1 * ZoomFactor), (CurrentSpawn.Y1 * ZoomFactor), Width, Height);
                using (Pen thisPen = new Pen(zzz, 1))
                { Map.CreateGraphics().DrawRectangle(thisPen, SpawnBox); }
                using (Font thisFont = new Font("Arial", 10))
                { Map.CreateGraphics().DrawString(CurrentSpawn.Name, thisFont, Brushes.GreenYellow, new Point((CurrentSpawn.X1 * ZoomFactor) + 10, (CurrentSpawn.Y1 * ZoomFactor))); }

            }
            for (int i = 0; i < Data.CustomZones.Count; i++)
            {
                SpawnZone CurrentSpawn = Data.CustomZones[i];
                Color zzz = Colourise();
                int Width = ((CurrentSpawn.X2 * ZoomFactor) - (CurrentSpawn.X1 * ZoomFactor));
                int Height = ((CurrentSpawn.Y2 * ZoomFactor) - (CurrentSpawn.Y1 * ZoomFactor));
                Rectangle SpawnBox = new Rectangle((CurrentSpawn.X1 * ZoomFactor), (CurrentSpawn.Y1 * ZoomFactor), Width, Height);
                using (Pen thisPen = new Pen(zzz, 1))
                { Map.CreateGraphics().DrawRectangle(thisPen, SpawnBox); }
                using (Font thisFont = new Font("Arial", 10))
                { Map.CreateGraphics().DrawString(CurrentSpawn.Name, thisFont, Brushes.GreenYellow, new Point((CurrentSpawn.X1 * ZoomFactor) + 10, (CurrentSpawn.Y1 * ZoomFactor))); }
            }
        }
        //######################################################################################
        //######################################################################################
        //Draw a rectangle on the picture frame with given co-ordinates.Confirm before adding to List<>
        private void ConfirmDrawSpawn(int X1, int Y1, int X2, int Y2)
        {
            //rectangles not drawing if x1/x2 and y1/y2 in wrong order
            //because draw process only uses one point and line lengths..
            //need to ensure lowest number first
            if ((X1 < X2) && (Y1 < Y2))
            {
                //Workout the width and height
                int Width = (X2 - X1);
                int Height = (Y2 - Y1);
                Color zzz = Colourise();
                //draw Rectangle
                Rectangle SpawnBox = new Rectangle(X1, Y1, Width, Height);
                using (Pen thisPen = new Pen(zzz, 1))
                { Map.CreateGraphics().DrawRectangle(thisPen, SpawnBox); }
                DialogResult result = MessageBox.Show("Do you really want to add this rectangle?", "Write confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (result == DialogResult.Yes)
                {
                    //Data.CustomBoxes.Add(SpawnBox);
                    consoleBox.Clear();//just clearing and giving feedback, mainly for troubleshooting
                    int count = (Data.CustomZones.Count + 1);
                    string theCount = count.ToString();
                    consoleBox.AppendText("Drawing rectangle # " + theCount);
                }
                else
                {
                    consoleBox.Clear();//just clearing and giving feedback, mainly for troubleshooting
                    consoleBox.AppendText("Last rectangle # " + Data.CustomZones.Count.ToString());
                }
            }
            else { consoleBox.AppendText("Please drag from top left to bottom right."); }

        }
        //populate the info for selected ListBox item.
        private void C_PopulateInfo(string _C_WhatSpawn)
        {

            for (int i = 0; i < Data.CustomZones.Count; i++)
            {
                if (Data.CustomZones[i].Name == _C_WhatSpawn)
                    C_SelectedC_Spawn = i;
            }
            buttonC_Update.Enabled = true;
            consoleBox.AppendText("The selected element is: " + Data.CustomZones[C_SelectedC_Spawn].Name);
            textBoxName.Text = _C_WhatSpawn;
            textBoxX1.Text = Data.CustomZones[C_SelectedC_Spawn].X1.ToString();
            textBoxY1.Text = Data.CustomZones[C_SelectedC_Spawn].Y1.ToString();
            textBoxX2.Text = Data.CustomZones[C_SelectedC_Spawn].X2.ToString();
            textBoxY2.Text = Data.CustomZones[C_SelectedC_Spawn].Y2.ToString();
            textBoxDelay.Text = Data.CustomZones[C_SelectedC_Spawn].tDelay.ToString();
            C_PopulateMobInfo(C_SelectedC_Spawn);  //making it separate for readability and testing
        }
        //populate the Mob combolist and amount for the selected SpawnZone
        private void C_PopulateMobInfo(int S_C_Spawn) //just shortening the "SelectedUOSpawn"
        {
            if ((Data.CustomZones[S_C_Spawn].Mob1) != null)
            {
                comboBox1.Text = Data.CustomZones[S_C_Spawn].Mob1;
                textBox1.Text = Data.CustomZones[S_C_Spawn].Amount1.ToString();
            }
            if (Data.CustomZones[S_C_Spawn].Mob2 != null)
            {
                comboBox2.Text = Data.CustomZones[S_C_Spawn].Mob2;
                textBox2.Text = Data.CustomZones[S_C_Spawn].Amount2.ToString();
            }
            if (Data.CustomZones[S_C_Spawn].Mob3 != null)
            {
                comboBox3.Text = Data.CustomZones[S_C_Spawn].Mob3;
                textBox3.Text = Data.CustomZones[S_C_Spawn].Amount3.ToString();
            }
            if (Data.CustomZones[S_C_Spawn].Mob4 != null)
            {
                comboBox4.Text = Data.CustomZones[S_C_Spawn].Mob4;
                textBox4.Text = Data.CustomZones[S_C_Spawn].Amount4.ToString();
            }
            if (Data.CustomZones[S_C_Spawn].Mob5 != null)
            {
                comboBox5.Text = Data.CustomZones[S_C_Spawn].Mob5;
                textBox5.Text = Data.CustomZones[S_C_Spawn].Amount5.ToString();
            }
            if (Data.CustomZones[S_C_Spawn].Mob6 != null)
            {
                comboBox6.Text = Data.CustomZones[S_C_Spawn].Mob6;
                textBox6.Text = Data.CustomZones[S_C_Spawn].Amount6.ToString();
            }
        }
        //clear last custom rectangle
        private void ClearLast()
        {
            int x = (Data.CustomZones.Count - 1);   //crashes if I remove the first entry, must do clear() for that.
            if (x == 0)
            {
                Data.CustomZones.Clear();
                consoleBox.AppendText("\r\nCustomZones empty.");
                CustomListBox.Items.Clear();
            }
            if (x > 0)
            {
                consoleBox.AppendText("\r\nRemoved entry");
                Data.CustomZones.RemoveAt(x);
                CustomListBox.Items.RemoveAt(x);
            }
            Map.Refresh();
            ReDrawSpawn();
        }
        //Create Custom SpawnZone List<>
        private void AddToCustomList(int spawnX1, int spawnY1, int spawnX2, int spawnY2)
        {
            SpawnZone thisSpawnZone = new SpawnZone();
            thisSpawnZone.Name = (textBoxName.Text);
            thisSpawnZone.X1 = (spawnX1);
            thisSpawnZone.Y1 = (spawnY1);
            thisSpawnZone.X2 = (spawnX2);
            thisSpawnZone.Y2 = (spawnY2);

            Data.CustomZones.Add(thisSpawnZone);
            CustomListBox.Items.Add(thisSpawnZone.Name);
        }
        //Save CustomZone back to cfg file
        private void SaveCustomZoneClassBackToCurlyBrace_CFG_File()
        {
            consoleBox.Clear();
            CustomSpawnsToSave = "#saving spawns#\r\n";
            for (int i = 0; i < Data.CustomZones.Count; i++)
            {
                CustomSpawnsToSave += ("Region \t");
                CustomSpawnsToSave += (Data.CustomZones[i].Name + "\r\n{\r\n\tCoords\t");
                CustomSpawnsToSave += (Data.CustomZones[i].X1.ToString() + "\t");
                CustomSpawnsToSave += (Data.CustomZones[i].Y1.ToString() + "\t");
                CustomSpawnsToSave += (Data.CustomZones[i].X2.ToString() + "\t");
                CustomSpawnsToSave += (Data.CustomZones[i].Y2.ToString() + "\r\n");
                CustomSpawnsToSave += ("\tSpawnWait\t" + Data.CustomZones[i].tDelay.ToString() + "\r\n");
                if ((Data.CustomZones[i].Mob1) != null)
                {
                    CustomSpawnsToSave += ("\tGroup\t" + Data.CustomZones[i].Mob1);
                    CustomSpawnsToSave += ("\t" + Data.CustomZones[i].Amount1.ToString() + "\r\n");
                }
                if (Data.CustomZones[i].Mob2 != null)
                {
                    CustomSpawnsToSave += ("\tGroup\t" + Data.CustomZones[i].Mob2);
                    CustomSpawnsToSave += ("\t" + Data.CustomZones[i].Amount2.ToString() + "\r\n");
                }
                if (Data.CustomZones[i].Mob3 != null)
                {
                    CustomSpawnsToSave += ("\tGroup\t" + Data.CustomZones[i].Mob3);
                    CustomSpawnsToSave += ("\t" + Data.CustomZones[i].Amount3.ToString() + "\r\n");
                }
                if (Data.CustomZones[i].Mob4 != null)
                {
                    CustomSpawnsToSave += ("\tGroup\t" + Data.CustomZones[i].Mob4);
                    CustomSpawnsToSave += ("\t" + Data.CustomZones[i].Amount4.ToString() + "\r\n");
                }
                if (Data.CustomZones[i].Mob5 != null)
                {
                    CustomSpawnsToSave += ("\tGroup\t" + Data.CustomZones[i].Mob5);
                    CustomSpawnsToSave += ("\t" + Data.CustomZones[i].Amount5.ToString() + "\r\n");
                }
                if (Data.CustomZones[i].Mob6 != null)
                {
                    CustomSpawnsToSave += ("\tGroup\t" + Data.CustomZones[i].Mob6);
                    CustomSpawnsToSave += ("\t" + Data.CustomZones[i].Amount6.ToString() + "\r\n");
                }
                CustomSpawnsToSave += ("}\r\n");

            }
            string SaveHereCS = SaveFile();
            AddToFile(CustomSpawnsToSave, SaveHereCS);
        }
        //Editing of the UOSpawns read from file
        private void C_Update()
        {
            for (int i = 0; i < Data.CustomZones.Count; i++)
            {
                if (Data.CustomZones[i].Name == CustomListBox.SelectedItem.ToString())
                    EditC_Spawn = i;
            }
            Data.CustomZones[EditC_Spawn].Name = textBoxName.Text;
            Data.CustomZones[EditC_Spawn].X1 = int.Parse(textBoxX1.Text);
            Data.CustomZones[EditC_Spawn].Y1 = int.Parse(textBoxY1.Text);
            Data.CustomZones[EditC_Spawn].X2 = int.Parse(textBoxX2.Text);
            Data.CustomZones[EditC_Spawn].Y2 = int.Parse(textBoxY2.Text);
            Data.CustomZones[EditC_Spawn].tDelay = int.Parse(textBoxDelay.Text);
            if ((comboBox1.Text != "") && (textBox1.Text != ""))
            {
                Data.CustomZones[EditC_Spawn].Mob1 = comboBox1.Text;
                Data.CustomZones[EditC_Spawn].Amount1 = int.Parse(textBox1.Text);
            }
            if ((comboBox2.Text != "") && (textBox2.Text != ""))
            {
                Data.CustomZones[EditC_Spawn].Mob2 = comboBox2.Text;
                Data.CustomZones[EditC_Spawn].Amount2 = int.Parse(textBox2.Text);
            }
            if ((comboBox3.Text != "") && (textBox3.Text != ""))
            {
                Data.CustomZones[EditC_Spawn].Mob3 = comboBox3.Text;
                Data.CustomZones[EditC_Spawn].Amount3 = int.Parse(textBox3.Text);
            }
            if ((comboBox4.Text != "") && (textBox4.Text != ""))
            {
                Data.CustomZones[EditC_Spawn].Mob4 = comboBox4.Text;
                Data.CustomZones[EditC_Spawn].Amount4 = int.Parse(textBox4.Text);
            }
            if ((comboBox5.Text != "") && (textBox5.Text != ""))
            {
                Data.CustomZones[EditC_Spawn].Mob5 = comboBox5.Text;
                Data.CustomZones[EditC_Spawn].Amount5 = int.Parse(textBox5.Text);
            }
            if ((comboBox6.Text != "") && (textBox6.Text != ""))
            {
                Data.CustomZones[EditC_Spawn].Mob6 = comboBox6.Text;
                Data.CustomZones[EditC_Spawn].Amount6 = int.Parse(textBox6.Text);
            }

            CustomListBox.Items.Clear();
            {
                for (int i = 0; i < Data.CustomZones.Count; i++)
                {
                    CustomListBox.Items.Add(Data.CustomZones[i].Name);
                }
            }
        }
        //######################################################################################
        //######################################################################################
        //Random Pen.Color
        public static Color Colourise()
        {
            Random random = new Random();
            return Color.FromArgb((byte)random.Next(0, 255), (byte)random.Next(0, 255), (byte)random.Next(0, 255));
        }
        //Clear the info boxes when drawing a new Zone
        private void ClearOldInfo()
        {
            buttonUpdate.Enabled = false;
            buttonC_Update.Enabled = false;
            consoleBox.Clear();
            textBoxName.Text = null;
            textBoxX1.Text = null;
            textBoxY1.Text = null;
            textBoxX2.Text = null;
            textBoxY2.Text = null;
            textBoxDelay.Text = null;
            comboBox1.Text = null;
            textBox1.Text = null;
            comboBox2.Text = null;
            textBox2.Text = null;
            comboBox3.Text = null;
            textBox3.Text = null;
            comboBox4.Text = null;
            textBox4.Text = null;
            comboBox5.Text = null;
            textBox5.Text = null;
            comboBox6.Text = null;
            textBox6.Text = null;
        }
        //Read in default groups and place in a listbox
        private string ReadGroupFile(string _GroupFile)
        {
            try
            {
                StreamReader myReader = new StreamReader(_GroupFile);
                string ThisLine = "";
                string dumpline = "";

                while (ThisLine != null)
                {
                    ThisLine = myReader.ReadLine();

                    if ((ThisLine == null) || (ThisLine == "") || (ThisLine == " ") || (!ThisLine.Contains("Group")))
                        dumpline = ThisLine;
                    else if (CleanStr(ThisLine) == false)
                        dumpline = ThisLine;
                    else
                    {
                        NewGroupFile += ( ThisLine);
                    }
                }
                myReader.Close();
                return NewGroupFile;
            }
            catch (DirectoryNotFoundException e)
            {
                consoleBox.AppendText(e.Message);
                return " Sorry.. error ";
            }
            catch (FileNotFoundException e)
            {
                consoleBox.AppendText(e.Message);
                return " Sorry.. error ";
            }
            catch (Exception e)
            {
                consoleBox.AppendText("oh Fuck! You broke it!" + e.Message);
                return " Sorry.. error ";
            }

        }
        //take the Mob info from GroupFile and put it in listbox for now
        private void PutMobListSomewhere()
        {
            string breaker = "Group";
            string[] Mobsplitter = NewGroupFile.Split(new string[] { breaker }, StringSplitOptions.RemoveEmptyEntries);
            
            for (int i = 0; i < Mobsplitter.Length; i++)
            {
                Data.MobString.Add(Mobsplitter[i]);                
            }
            for (int i = 0; i < Data.MobString.Count; i++)
            {
                //MobListBox.Items.Add(Data.MobString[i]);
                comboBox1.Items.Add(Data.MobString[i]);
                comboBox2.Items.Add(Data.MobString[i]);
                comboBox3.Items.Add(Data.MobString[i]);
                comboBox4.Items.Add(Data.MobString[i]);
                comboBox5.Items.Add(Data.MobString[i]);
                comboBox6.Items.Add(Data.MobString[i]);
            }
            consoleBox.AppendText(" \r\nAdded " + Data.MobString.Count.ToString() + " Mob groups.");
        }
        //Create SpawnZones from ZonesAsArray and store in List<SpawnZone> = UOSpawns
        private void PutZonesAsArrayIntoSpawnZoneList()
        {
            for (int i = 0; i < Data.ZonesAsArray.Count; i++)
            {
                SpawnZone thisSpawnZone = new SpawnZone();

                //throws unhandled exception error if it tries to read beyond the length of the array.
                //so getting array length and stopping before.
                int StopAT = Data.ZonesAsArray[i].Length;
                if (StopAT > 8)
                {
                    thisSpawnZone.Name = (Data.ZonesAsArray[i][1]);
                    thisSpawnZone.X1 = (int.Parse(Data.ZonesAsArray[i][3]));
                    thisSpawnZone.Y1 = (int.Parse(Data.ZonesAsArray[i][4]));
                    thisSpawnZone.X2 = (int.Parse(Data.ZonesAsArray[i][5]));
                    thisSpawnZone.Y2 = (int.Parse(Data.ZonesAsArray[i][6]));
                    thisSpawnZone.tDelay = (int.Parse(Data.ZonesAsArray[i][8]));

                }
                if (StopAT > 11)
                { 
                    thisSpawnZone.Mob1 = (Data.ZonesAsArray[i][10]);
                    thisSpawnZone.Amount1 = (int.Parse(Data.ZonesAsArray[i][11]));
                }
                if (StopAT > 14)
                {
                    thisSpawnZone.Mob2 = (Data.ZonesAsArray[i][13]);
                    thisSpawnZone.Amount2 = (int.Parse(Data.ZonesAsArray[i][14]));
                }
                if (StopAT > 17)
                {
                    thisSpawnZone.Mob3 = (Data.ZonesAsArray[i][16]);
                    thisSpawnZone.Amount3 = (int.Parse(Data.ZonesAsArray[i][17]));
                }
                if (StopAT > 20)
                {
                    thisSpawnZone.Mob4 = (Data.ZonesAsArray[i][19]);
                    thisSpawnZone.Amount4 = (int.Parse(Data.ZonesAsArray[i][20]));
                }
                if (StopAT > 23)
                {
                    thisSpawnZone.Mob5 = (Data.ZonesAsArray[i][22]);
                    thisSpawnZone.Amount5 = (int.Parse(Data.ZonesAsArray[i][23]));
                }

                if (StopAT > 26)
                {
                    thisSpawnZone.Mob6 = (Data.ZonesAsArray[i][25]);
                    thisSpawnZone.Amount6 = (int.Parse(Data.ZonesAsArray[i][26]));
                }

                if (StopAT > 29)
                {
                    thisSpawnZone.Mob7 = (Data.ZonesAsArray[i][28]);
                    thisSpawnZone.Amount7 = (int.Parse(Data.ZonesAsArray[i][29]));
                }

                if (StopAT > 32)
                {
                    thisSpawnZone.Mob8 = (Data.ZonesAsArray[i][31]);
                    thisSpawnZone.Amount8 = (int.Parse(Data.ZonesAsArray[i][32]));
                }

                if (StopAT > 35)
                {
                    thisSpawnZone.Mob9 = (Data.ZonesAsArray[i][34]);
                    thisSpawnZone.Amount9 = (int.Parse(Data.ZonesAsArray[i][35]));
                }
                Data.UOSpawns.Add(thisSpawnZone);
            }
            consoleBox.AppendText("\r\nAdded " + Data.UOSpawns.Count + " SpawnZones to List<SpawnZone>UOSpawns");
        }
        //######################################################################################
        //######################################################################################
    }
    public static class Data
    {
        //Create a list of ARRAYS for each element. Each WORD in the element is a separate STRING in the ARRAY for that element.
        public static List<string[]> ZonesAsArray = new List<string[]>();
        //string list for the Mobs
        public static List<string> MobString = new List<string>();
        //Create list of all drawn rectangles for updating.
        public static List<SpawnZone> RedrawZones = new List<SpawnZone>();
        //create list of "custom" rectangles to be saved back to spawnfile or to separate file
        public static List<SpawnZone> CustomZones = new List<SpawnZone>();
        //SpawnZone class for importing info from file and manipulating from there.
        public static List<SpawnZone> UOSpawns = new List<SpawnZone>();
    }
    //template for SpawnZone items.
    //space for 9 groups incase an existing file has that many, but only write back 6 max.
    public class SpawnZone
    {
        public string Name { get; set; }
        public int X1 { get; set; }
        public int Y1 { get; set; }
        public int X2 { get; set; }
        public int Y2 { get; set; }
        public int tDelay { get; set; }
        public string Mob1 { get; set; }
        public int Amount1 { get; set; }
        public string Mob2 { get; set; }
        public int Amount2 { get; set; }
        public string Mob3 { get; set; }
        public int Amount3 { get; set; }
        public string Mob4 { get; set; }
        public int Amount4 { get; set; }
        public string Mob5 { get; set; }
        public int Amount5 { get; set; }
        public string Mob6 { get; set; }
        public int Amount6 { get; set; }
        public string Mob7 { get; set; }
        public int Amount7 { get; set; }
        public string Mob8 { get; set; }
        public int Amount8 { get; set; }
        public string Mob9 { get; set; }
        public int Amount9 { get; set; }


        private void MakeRectangle()
        {
            int Width = (this.X2 - this.X1);
            int Height = (this.Y2 - this.Y1);
            Rectangle SpawnBox = new Rectangle(this.X1, this.Y1, Width, Height);
            Data.RedrawZones.Add(this);
        }
    }
}
